#include <iostream>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <fstream>

using namespace std;

int result = 0, result_ = 0; // переменные, необходимые для подсчета количества результатов
                             // result - для вывода на экране, result_ - для вывода в файл

int quantity, **chess_board, SIZE, choise; //quantity - количество фигур, для которых идет перебор значений
                                           //**chess_board - динамический двумерный массив
                                           //SIZE - размер
                                           //choise - переменная для выбора в меню

string type; //type - необходима для работы с типом фигуры

void null_board () //функция, необходимая для создания и обнуления массива
{
    chess_board = new int*[SIZE];
    for (int i = 0; i < SIZE; i++)
        chess_board[i] = new int[SIZE]; //создание
    for (int i = 0; i < SIZE; i++)
        for (int j = 0; j < SIZE; j++)
            chess_board[i][j] = 0; // обнуление
}

void board(string L) //функция, для вывода доски на экран
{
    cout << "==========================================" << endl;
    for(int i = 0; i < SIZE; ++i) //строки
    {
        for(int j = 0; j < SIZE; ++j) //столбики
            cout << ((chess_board[i][j]) ? L : " 0 "); //заполнение массива: если '+',то фигура находится на том
                                                       // месте, где и данный символ, '0' - если клетка пуста
        cout << endl;
    }
    cout << "------------------------------------------" << endl;
    cout << "Result № " << ++result << "\n"; //Вывод номера получившегос результата
    cout << "==========================================" << endl;
    return;
}

void save(string L) //функция, для сохранения доски в файл
{
    ofstream out("figure", ios::app); //сохранение в файл "figure", ios::app - добавление результатов в конец
    out << "==========================================" << endl; //сохранение того же цикла, что и для вывода на экран
    for(int i = 0; i < SIZE; ++i)
    {
        for(int j = 0; j < SIZE; ++j)
            out << ((chess_board[i][j]) ? L : " 0 ");
        out << endl;
    }
    out << "------------------------------------------" << endl;
    out << "Result № " << ++result_ << "\n";//Вывод номера получившегос результата
    out << "==========================================" << endl;
    return;
    out.close();//Закрытие рабочего файла
}

bool check_queen(int x, int y) //для проверки позиций, на которых может находиться королева
{
    for (int i = 0; i < SIZE; ++i) //проверка для строки
    {
        if(chess_board[x][i]) //если что-то находится в строке, то вернуть 0,т.е. false
            return false;
    }

    for(int i = 0; i < SIZE; ++i) //проверка для столбца
    {
        if(chess_board[i][y]) //если что-то уже стоит, то вернуть 0
            return false;
    }

    for(int i = 1; x-i >= 0 && y-i >= 0; ++i) //проверка для диагонали влево-вверх
    {
        if(chess_board[x-i][y-i])
            return false;
    }

    for(int i = 1; x+i < SIZE && y+i < SIZE; ++i) //проверка для диагонали вправо-вниз
    {
        if(chess_board[x+i][y+i]) //если что-то стоит, то вернуть 0
            return false;
    }

    for(int i = 1; x+i < SIZE && y-i >= 0; ++i) //проверка для диагонали влево-вниз
    {
        if(chess_board[x+i][y-i]) //если что-то стоит, то вернуть 0
            return false;
    }

    for(int i = 1; x-i >= 0 && y+i < SIZE; ++i) //проверка для диагонали вправо-вверх
    {
        if(chess_board[x-i][y+i]) //если что-то стоит, то вернуть 0
            return false;
    }
    return true; //если во время проверки фигуры нигде не обнаружилось, то вернуть 1
}

bool check_rook(int x, int y) //проверка для ладьи
{
    for (int i = 0; i < SIZE; ++i) //проверка для строки
    {
        if(chess_board[x][i]) //если что-то стоит, то вернуть 0
            return false;
    }

    for(int i = 0; i < SIZE; ++i) //роверка для столбца
    {
        if(chess_board[i][y]) //если что-то стоит, то вернуть 0
            return false;
    }
    return true; //иначе вернуть 1
}

bool check_bishop(int x, int y) //проверка для слона
{
    for(int i = 1; x-i >= 0 && y-i >= 0; ++i) //проверка для диагонали влево-вверх
    {
        if(chess_board[x-i][y-i]) //если что-то стоит, то вернуть 0
            return false;
    }

    for(int i = 1; x+i < SIZE && y+i < SIZE; ++i) //проверка для диагонали вправо-вниз
    {
        if(chess_board[x+i][y+i]) //если что-то стоит, то вернуть 0
            return false;
    }

    for(int i = 1; x+i < SIZE && y-i >= 0; ++i) //проверка для диагонали влево-вниз
    {
        if(chess_board[x+i][y-i])//если что-то стоит, то вернуть 0
            return false;
    }

    for(int i = 1; x-i >= 0 && y+i < SIZE; ++i) //проверка для диагонали вправо-вверх
    {
        if(chess_board[x-i][y+i]) //если что-то стоит, то вернуть 0
            return false;
    }
    return true; //иначе вернуть 1
}

bool check_knight(int x, int y) //проверка для коня
{

    if ((x-1) >=0 && (y-2)>=0 && chess_board[x-1][y-2]) //если что-то стоит, то вернуть 0
        return false;

    if ((x-1)>=0 && (y+2) < SIZE && chess_board[x-1][y+2]) //если что-то стоит, то вернуть 0
        return false;

    if ((x+1) < SIZE && (y-2) >=0 && chess_board[x+1][y-2]) //если что-то стоит, то вернуть 0
        return false;

    if ((x+1) < SIZE && (y+2) < SIZE && chess_board[x+1][y+2]) //если что-то стоит, то вернуть 0
        return false;

    if ((x-2) >=0 && (y-1) >=0 && chess_board[x-2][y-1]) //если что-то стоит, то вернуть 0
        return false;

    if ((x-2) >=0 && (y+1) < SIZE && chess_board[x-2][y+1]) //если что-то стоит, то вернуть 0
        return false;

    if ((x+2) < SIZE && (y-1) >= 0 && chess_board[x+2][y-1]) //если что-то стоит, то вернуть 0
        return false;

    if ((x+2) < SIZE && (y+1) < SIZE && chess_board[x+2][y+1]) //если что-то стоит, то вернуть 0
        return false;

    return true; //иначе вернуть 1
}

bool check_king(int x, int y) //проверка для короля, в районе точек 3*3 вокруг него
{
    for(int i = x-1; i <= x+1; ++i)
    {
        for(int j = y-1; j <= y+1; ++j)
        {
            if (x >= 0 && x < SIZE && y >= 0 && y < SIZE && chess_board[x][y]) //если что-то стоит, то вернуть 0
                return false;

            if ((x+1) < SIZE && (y-1) >= 0 && chess_board[x+1][y-1]) //если что-то стоит, то вернуть 0
                return false;

            if ((x+1) < SIZE && chess_board[x+1][y]) //если что-то стоит, то вернуть 0
                return false;

            if ((x+1) < SIZE && (y+1) < SIZE && chess_board[x+1][y+1]) //если что-то стоит, то вернуть 0
                return false;

            if ((x+1) < SIZE && chess_board[x][y+1]) //если что-то стоит, то вернуть 0
                return false;

            if ((x-1) >= 0 && (y+1) < SIZE && chess_board[x-1][y+1]) //если что-то стоит, то вернуть 0
                return false;

            if ((x-1) >=0 && chess_board[x-1][y]) //если что-то стоит, то вернуть 0
                return false;

            if ((x-1) >=0 && (y-1)>=0 && chess_board[x-1][y-1]) //если что-то стоит, то вернуть 0
                return false;

            if ((y-1) >= 0 && chess_board[x][y-1]) //если что-то стоит, то вернуть 0
                return false;
        }
    }
    return true; //иначе вернуть 1
}

void king (int count, int x, int y) //функция расстановки королей
{
    if(count == quantity) //если количество фигур достигает заданного пользователем
    {
        board(" + "); //то идет вывод результатов на экран
        save (" + "); //и вывод результатов в файл
        return;
    }

    for (int j = y; j < SIZE; ++j) //расстановка в первой строке
    {
        if(check_king(x, j)) //проверка на возможность постановки фигуры в клетки
        {
            chess_board[x][j]=1; //если есть возможность - то ставится 1
            king(count+1,x,j); //в таком случае, количество поставленных фигур растет
            chess_board[x][j]=0; // остальное заполнить нулями
        }
    }

    for(int i = x+1; i < SIZE; ++i) //прогон дальнейшего цикла по доске
    {
        for (int j = 0; j < SIZE; ++j)
        {
            if(check_king(i, j)) //проверка на возможность постановки фигуры в клетки
            {
                chess_board[i][j]=1; //если есть возможность - то ставится 1
                king(count+1,i,j); //в таком случае, количество поставленных фигур растет
                chess_board[i][j]=0; // остальное заполнить нулями
            }
        }
    }
}

void queen(int x, int count) //функция расстановки королев
{
    for(int y = 0; y < SIZE; ++y) //цикл по столбцам и строкам
    {
        if(check_queen(x, y)) //проверка на возможность постановки фигуры в клетки
        {
            chess_board[x][y] = 1; //если есть возможность - то ставится 1

            for(int i = x + 1; i < SIZE; ++i)
                queen(i,count+1); //количество поставленных фигур растет

            if(count+1 == quantity) //если количество фигур достигает заданного пользователем
            {
                board(" + "); //то идет вывод результатов на экран
                save (" + "); //и вывод результатов в файл
            }

            chess_board[x][y]=0; // остальное заполнить нулями
        }
    }
}

void rook(int x, int count) //функция для расстановки ладей
{
    for(int y = 0; y < SIZE; ++y) //цикл по столбцам и строкам
    {
        if(check_rook(x, y)) //проверка на возможность постановки фигуры в клетки
        {
            chess_board[x][y] = 1; //если есть возможность - то ставится 1

            for(int i = x + 1; i < SIZE; ++i)
                rook(i,count+1); //количество поставленных фигур растет

            if(count+1 == quantity) //если количество фигур достигает заданного пользователем
            {
                board(" + "); //то идет вывод результатов на экран
                save (" + "); //и вывод результатов в файл
            }

            chess_board[x][y]=0; // остальное заполнить нулями
        }
    }
}

void bishop (int c, int count) //с - диагональ. Функция для постановки слонов
{
    int x, y; //переменные для работы со строками и столбцами

    if (c < SIZE) //если диагональ внутри поля
    {
        x = c;
        y = 0;
    }
    else
    {
        x = SIZE-1; //если диагональ выходит за преелы поля
        y =(c % SIZE)+1;
    }

    for(int i=0; x-i>=0 && y+i < SIZE; ++i) // цикл движется по строкам и столбцам снизу слева вправо вверх
    {
        int line = x-i; //для строк
        int column = y+i;//для столбцов

        if(check_bishop(line, column))  // возможность проверки постановки фигуры
        {
            chess_board[line][column]=1; //если есть возможность - то ставится 1

            for(int i = c + 1; i<2*SIZE-1; ++i)
                bishop(i,count+1); //увеличение кол-ва поставленных фигур

            if(count+1 == quantity) //если количество фигур достигает заданного пользователем
            {
                board(" + "); //то идет вывод результатов на экран
                save (" + "); //и вывод результатов в файл
            }

            chess_board[line][column]=0;// обнуление
        }
    }
}

void knight(int count, int x, int y) // для работы с конями
{
    if(count == quantity) //если количество фигур достигает заданного пользователем
    {
        board(" + "); //то идет вывод результатов на экран
        save (" + "); //и вывод результатов в файл
    }

    if (x == SIZE) // для работы со строками
        return;

    for (int j = y; j < SIZE; ++j) //установка коней в первой строке
    {
        if(check_knight(x, j)) // возможность проверки постановки фигуры
        {
            chess_board[x][j]=1; //если есть возможность - то ставится 1
            int line = x, y = j+1; //смещение в строке на одну позицию вправо, переобозначение строки на line

            if (y == SIZE) //если данный столбец - самый крайний
            {
                y = 0; //обнуление
                line++; //переход на следующую строку
            }
            knight(count+1,line,y); //увеличение кол-ва поставленных фигур
            chess_board[x][j]=0; // остальное заполнить нулями
        }
    }

    for(int i = x+1; i < SIZE; ++i) //установка коней в последующих стрках
    {
        for (int j = 0; j < SIZE; ++j)
        {
            if(check_knight(i, j)) // возможность проверки постановки фигуры
            {
                chess_board[i][j]=1; //если есть возможность - то ставится 1
                int line = i, y = j+1;

                if (y == SIZE) //если данный столбец - самый крайний
                {
                    y = 0; //обнуление
                    line++; //переход на следующую строку
                }
                knight(count+1,line,y); //увеличение кол-ва поставленных фигур
                chess_board[i][j]=0; // остальное заполнить нулями
            }
        }
    }
}

int max_quantity (int SIZE) //функция, необходимая для вычисления максимального значения фигур на заданной доске
{
    cout << "Input type of figure: " << endl;
    cout << "king, queen, rook, bishop, knight" << endl;
    cout << "------------------------------------------" << endl;
    cin >> type; // ввод типа фигуры
    if (type == string ("king")) //король
        cout << "Max: "<< (SIZE*SIZE)/4 << endl;
    if (type == string ("queen")) //королева
    {
        if (SIZE == 3)
        {
            cout << "Max: "<< 2 << endl;
        }
        else
        {
            cout << "Max: "<< SIZE << endl;
        }
    }
    if (type == string ("rook")) //ладья
        cout << "Max: "<< SIZE << endl;
    if (type == string ("bishop")) //слон
        cout << "Max: "<< (SIZE*2)-2 << endl;
    if (type == string ("knight")) //конь
        cout << "Max: "<< (SIZE*SIZE)/2 << endl;
    return 1;
}


int main()
{
    ofstream file("figure", ios::trunc); //очищение файла от значений
    file.close();

    do //продолжать цикл до выполнения условия делимости на 2
    {
        cout << "You can input only even values." << endl;
        cout << "Input the size of the board: ";
        cin >> SIZE; //размер доски
        if ( (SIZE%2) == 1) //если ввели нечетное число
        {
            cout << '\n' << "The number must be even, so try to input the size again" << '\n' << endl;
        }
    }
    while (SIZE%2 != 0); //верное условие

    null_board();
    cout << "------------------------------------------" << endl;
    cout << "You can choose these actions: " << endl;
    cout << "1. Maximum number of figures on the board;" << endl;
    cout << "2. Placing of figures." << endl;
    cin >> choise; //выбор дальнейших дейстрвий
    cout << "------------------------------------------" << endl;

    if (choise == 1) //работа с максимальным значением
    {
        max_quantity(SIZE);//вывод на экран
    }
    if (choise == 2) //работа с расстановкой фигур
    {
        max_quantity(SIZE); //вывод максимального значения
        cout << "Input the amount of figures" << endl;
        cout << "The amount must not exceed the max" << endl;
        cout << "All results will save in file" << endl;
        cin >> quantity; //ввод пользователем значения не превышающее максимальное
        if (type == string ("king")) //для короля
            king(0,0,0);
        if (type == string ("queen")) //для королевы
        {
            for (int i = 0; i < SIZE; ++i)
                queen(i,0);
        }
        if (type == string ("rook")) //для ладьи
        {
            for (int i = 0; i < SIZE; ++i)
                rook(i,0);
        }
        if (type == string ("bishop")) //для слона
        {
            for (int i = 0; i < SIZE; ++i)
                bishop(i,0);
        }
        if (type == string ("knight")) //для коня
            knight(0,0,0);
    }
}
